
-------------------------------------------------------------------------------
-- Optimization
-------------------------------------------------------------------------------

-- GLOBALS: ChatFrame1, IsAddOnLoaded, next

-------------------------------------------------------------------------------
-- Namespace
-------------------------------------------------------------------------------

local A, B, C, D = unpack(select(2, ...)) -- AddOn, Border, Constants, Database
local M = A:NewModule("Integration BadBoy")

-------------------------------------------------------------------------------
-- Module
-------------------------------------------------------------------------------

function M:OnEnable()
	if not IsAddOnLoaded("BadBoy") then
		self:RegisterEvent("ADDON_LOADED")
		return
	end

	self:FindButton()
end

-- Determine whether a frame is likely to be BadBoy's button.
function M:IsButton(frame)
	return frame:IsObjectType("Frame") and frame:GetFrameStrata() == "DIALOG"
end

-- Find BadBoy's button.
function M:FindButton()
	for _, frame in next, {ChatFrame1:GetChildren()} do
		if self:IsButton(frame) then
			self:HideButton(frame)
		end
	end
end

-- Hide BadBoy's button.
function M:HideButton(frame)
	if not self:IsHooked(frame, "OnShow") then
		self:HookScript(frame, "OnShow", frame.Hide)
	end
end

-------------------------------------------------------------------------------
-- Events
-------------------------------------------------------------------------------

function M:ADDON_LOADED(event, name)
	if name == "BadBoy" then
		self:UnregisterEvent("ADDON_LOADED")
		self:OnEnable()
	end
end
